use std::env;

mod identity;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
  let url_broker = match env::var_os("URL_BROKER") {
    Some(v) => v.into_string().unwrap(),
    None => "".to_string(),
  };
  let queue_broker = match env::var_os("QUEUE_BROKER") {
    Some(v) => v.into_string().unwrap(),
    None => "".to_string(),
  };

  let broker_opts = nats::asynk::Options::new();
  let connection_broker = broker_opts.connect(url_broker).await?;

  let identity_service = identity::service::Service::new(connection_broker, queue_broker);

  println!("Server edge[beteran-frontend-server-edge] is started");

  futures::try_join!(identity_service.subscribe())?;

  Ok(())
}
